#include <string>
#include <vector>

class Latin1ToUtf8 {
    
public:

    Latin1ToUtf8(char const *input)
    :   ptr((unsigned char const *) input) {
    }

    void convert(char const *&begin, char const *&end) {
        while (convert_seq()) {
            // empty
        }
        static char const *emptyStr = "";
        if (out.empty()) {
            begin = emptyStr;
            end = emptyStr;
        } else {
            begin = (char const *) &out[0];
            end = begin + out.size();
        }
    }

private:

    void append(unsigned char c) {
        out.push_back(c);
    }

    bool convert_seq()  {
        unsigned char const c = *ptr++;
        if (c == 0) {
            return false;
        }
        if (c < 128) {
            append(c);
        } else {
            append(0xC0 | (c >> 6));
            append(0x80 | (c & 0x3F));
        }
        return true;
    }

    std::vector<unsigned char> out;  
    unsigned char const *ptr;
};
